; Cooperative thread demo. Two threads move separate objects'
; across the screen at different rates. The calls to yield
; switch to the other thread where it last called yield. See
; threading.asm for thread handling code.

      .include "shell.asm"
      .include "threading.asm"
main:
      ; Fork second thread
      jsr   fork
      bcs   thread2
      
; Both these loops run simultaneously
thread:
      ldy   #20         ; delay
dly:  jsr   yield
      dey
      bne   dly
      inc   sprite0_x   ; move sprite
      jmp   thread
      
thread2:
      ldy   #50         ; delay longer
dly2: jsr   yield
      dey
      bne   dly2
      inc   sprite1_x   ; move sprite
      jmp   thread2
      
; not used
irq:  rti
      
